function [phi,phix,phiy,phiz,phixx,phiyy,phizz] = csrbf(x,xc,R)

phi = zeros(size(x,1),1); 
phix = phi; phiy = phi; phiz = phi;
phixx = phi; phiyy = phi; phizz = phi;

ep = 1/R;
dx = x(:,1)-xc(1);
dy = x(:,2)-xc(2);
dz = x(:,3)-xc(3);
r = sqrt(dx.^2 + dy.^2 + dz.^2);
in = r <= R;
rin = r(in); dxin = dx(in); dyin = dy(in); dzin = dz(in);
rin2 = rin.^2; dxin2 = dxin.^2; dyin2 = dyin.^2; dzin2 = dzin.^2;

% % (1-ep*r)^4*(4*ep*r + 1)
% Not yet written
         
% (1-ep*r)^6*(35*ep^2*r^2 + 18*ep*r + 3)
phi(in) = (35*ep^2*rin2 + 18*ep*rin + 3).*(1-ep*rin).^6;

phix(in) = 56*ep^2*dxin.*(-1+ep*rin).^5.*(1+5*ep*rin);
phiy(in) = 56*ep^2*dyin.*(-1+ep*rin).^5.*(1+5*ep*rin);
phiz(in) = 56*ep^2*dzin.*(-1+ep*rin).^5.*(1+5*ep*rin);

phixx(in) = 56*ep^2*(-1+ep*rin).^4.*(-1-4*ep*rin+5*ep^2*(6*dxin2 + rin2));
phiyy(in) = 56*ep^2*(-1+ep*rin).^4.*(-1-4*ep*rin+5*ep^2*(6*dyin2 + rin2));
phizz(in) = 56*ep^2*(-1+ep*rin).^4.*(-1-4*ep*rin+5*ep^2*(6*dzin2 + rin2));
end

