function [qbox,qdist] = getclosestsphereind(xi,box,nbox,center)
% Get an index of closest circle to xi using 
% depth-first search algorithm.

%numdist = 0;
qbox = []; qdist = []; 
queuenn = eye(nbox,1);
nqueue = 1; endqueue = nqueue;
n = 8;
vec1n = 1:n;

r = inf;  % ceiling on the radius
rconst = 0.5*sqrt(3);

while nqueue <= endqueue
    b = queuenn(nqueue);
    nqueue = nqueue+1;
 
    % Compute distance
    dist = sqrt(sum((xi-box(b).midpt).^2,2));
    %numdist = numdist+1;

    % Test box for intersection with the r-disk around x
    if dist > (r + rconst*box(b).dimen(1)), continue, end

    if ~center(b)
        if isempty(box(b).child), continue, end
            
        queuenn(endqueue+vec1n) = box(b).child;
        endqueue = endqueue + n;
    elseif dist < r      
        qbox = b;
        qdist = dist;
        r = qdist;
    end
end
