function box = initboxes3d(x1,x2,y1,y2,z1,z2,rof)
% [x1 x2] x [y1 y2] x [z1,z2]

if (x1 < x2) && (y1 < y2) && (z1 < z2)
    % Create boxes
    deltax = x2-x1; deltay = y2-y1; deltaz = z2-z1;
    x = 0.5*(x1 + x2); y = 0.5*(y1 + y2); z = 0.5*(z1 + z2);
    [X,Y,Z] = meshgrid(x,y,z);
    N = length(X(:));
    xi = num2cell([X(:) Y(:) Z(:)],2);
    [box(1:N).midpt] = deal(xi{:});
    [box.dimen] = deal([deltax deltay deltaz]);
    [box.child] = deal([]);
    [box.depth] = deal(0);
    [box.Nchild] = deal(8);
    [box.parent] = deal([]);
    R = 0.5*sqrt(sum(box.dimen.^2,2));
    [box.R] = deal(rof*R); % Radius is rof*R
    [box.Rmax] = deal(0);
    [box.indlocpts] = deal([]);
    [box.Psi] = deal([]);
    [box.ep] = deal([]);
    [box.nnupdate] = deal(false);
end